moMouseKeyMohPDA = {};

function moMouseKeyMohPDA:setEventButtonLeft(self, clickAreaTable, whichPDA, mouseClickType)
	local whichSubPDA = whichPDA or "masterPDA_";
	if string.len(clickAreaTable.whatClick) > 0 and mouseClickType == "mouseButtonLeft" then
		if clickAreaTable.whatClick == "dragDrop" then			
			if not MultiOverlayV3.dragDropPos.on then				
				MultiOverlayV3.dragDropPos.on = true;				
				MultiOverlayV3.dragDropPos.whatDragDrop = tostring(clickAreaTable.whereClick);
				moSetGetOverlays.pda[whichSubPDA].autoPosMiddle = false;
				g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;
			elseif MultiOverlayV3.dragDropPos.on and not isDown and MultiOverlayV3.dragDropPos.whatDragDrop == whichSubPDA then
				MultiOverlayV3:stopDragDrop(self);									
			end;
		elseif clickAreaTable.whatClick == "closePda" then 
			moSetGetMohPDA.closePDA(whichSubPDA, true);				
		elseif clickAreaTable.whatClick == "lineLeft" and clickAreaTable.line > 0 then 
			moMouseKeyMohPDA:nextAppSelect(self, true, clickAreaTable.line, whichSubPDA);
		elseif clickAreaTable.whatClick == "lineRight" and clickAreaTable.line > 0 then
			moMouseKeyMohPDA:nextAppSelect(self, false, clickAreaTable.line, whichSubPDA);
		elseif clickAreaTable.whatClick == "lineUp" then
			moMouseKeyMohPDA:nextViewLine(self, true, whichSubPDA);
		elseif clickAreaTable.whatClick == "lineDown" then
			moMouseKeyMohPDA:nextViewLine(self, false, whichSubPDA);
		elseif clickAreaTable.whatClick == "pdaSetting" then
			moMouseKeyMohPDA:openSetting(self, whichSubPDA, 1);			
		elseif clickAreaTable.whatClick == "lineSetting" then
			--g_currentMission:showBlinkingWarning("click lineSetting ".. tostring(clickAreaTable.line), 2500);
		elseif clickAreaTable.whatClick == "appSetting" then
			--g_currentMission:showBlinkingWarning("click appSetting ".. tostring(clickAreaTable.appIcon), 2500);
		elseif clickAreaTable.whatClick == "appClickNormal" then --line is not select line			
			--g_currentMission:showBlinkingWarning("click appClickNormal".. tostring(clickAreaTable.appIcon), 2500);
			moMouseKeyMohPDA:setColorIconTyp3(self, clickAreaTable, whichSubPDA);			
			moSetGetCmd:setPdaCmd(whichSubPDA, clickAreaTable, true, "mouseButtonLeft");			
			return;
		elseif clickAreaTable.whatClick == "appClickOpenSetting" then --line is select line
			
			local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=1, name="newPdaLine_", pageGlobalName=whichSubPDA} );
			if getThisButtonPage == nil then return;end;
			if getThisButtonPage.slavePage ~= nil and getThisButtonPage.slavePage ~= g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.slavePage then
				--g_currentMission:showBlinkingWarning("click appClickOpenSetting falsches PDA".. tostring(clickAreaTable.appIcon), 2500);
				return;
			end;
			local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
			if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end;
			local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
			local lineSelect = moSetGetMohPDA:getLineMouseSelect(whichSubPDA); --moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
			if lineSelect == clickAreaTable.line then				
				moMouseKeyMohPDA:appSelectOrOpenApp(self, clickAreaTable, whichSubPDA);				
				--g_currentMission:showBlinkingWarning("click appClick Setting Line".. tostring(clickAreaTable.appIcon), 2500);
			else
				--g_currentMission:showBlinkingWarning("click appClickOpenSetting Other Line ".. tostring(clickAreaTable.appIcon), 2500);
				moSetGetMohPDA:setKeyAndAppMouseSelect(clickAreaTable.line, clickAreaTable.appIcon, false, true, whichSubPDA);
				--moSetGetGuiMenue:resetSelectPullDownLine(self, nil, nil, buttonTable, clickAreaTable.line, whichSubPDA)
				moSetGetGuiMenue:setAppMouseSelectButtoTxt(whichSubPDA, true, true, true, true);
			end;		
		end;	
	end;	
end;


function moMouseKeyMohPDA:setEventButtonScroll(self, clickAreaTable, scrollUp, scrollDown, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_";
	if string.len(clickAreaTable.whatClick) > 0 then
		if clickAreaTable.whatClick == "scrollPDA" and scrollUp and moSetGetOverlays.pda[whichSubPDA].viewLines < #moSetGetOverlays.pda[whichSubPDA].line then --scoll lines at PDA
			moMouseKeyMohPDA:nextViewLine(self, true);				
		elseif clickAreaTable.whatClick == "scrollPDA" and scrollDown and moSetGetOverlays.pda[whichSubPDA].viewLines < #moSetGetOverlays.pda[whichSubPDA].line then
			moMouseKeyMohPDA:nextViewLine(self, false);				
		end;
	end;
end;

function moMouseKeyMohPDA:setEventButtonMiddle(self, clickAreaTable, whichPDA, mouseClickType)
	local whichSubPDA = whichPDA or "masterPDA_";
	if string.len(clickAreaTable.whatClick) > 0 and mouseClickType == "mouseButtonMiddle" then
		if MultiOverlayV3.guiMenue.on == nil or not MultiOverlayV3.guiMenue.on then
			if clickAreaTable.whatClick == "appClickNormal" then --line is not select line				
				moSetGetCmd:setPdaCmd(whichSubPDA, clickAreaTable, true, "mouseButtonMiddle");			
			end;
			return;
		end;
	end;	
end;

function moMouseKeyMohPDA:setEventButtonRight(self, clickAreaTable, whichPDA, mouseClickType)
	local whichSubPDA = whichPDA or "masterPDA_";
	if string.len(clickAreaTable.whatClick) > 0 and mouseClickType == "mouseButtonRight" then
		if MultiOverlayV3.guiMenue.on == nil or not MultiOverlayV3.guiMenue.on then	
			if clickAreaTable.whatClick == "appClickNormal" then --line is not select line				
				moSetGetCmd:setPdaCmd(whichSubPDA, clickAreaTable, true, "mouseButtonRight");			
			end;
			return;
		elseif MultiOverlayV3.guiMenue.on ~= nil and MultiOverlayV3.guiMenue.on then
			if clickAreaTable.whatClick == "appClickOpenSetting" then				
				if moSetGetOverlays.iconPreviewPDA.selectIcon <= 0 then return;end;
				local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
				local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);				
				if isSelect then					
					local iconName = moSetGetOverlays.iconPreviewPDA.iconOverlay[moSetGetOverlays.iconPreviewPDA.selectIcon].name;
					local iconTyp = moSetGetOverlays.iconPreviewPDA.iconOverlay[moSetGetOverlays.iconPreviewPDA.selectIcon].iconTyp;
					local infoTxt = moSetGetOverlays.iconPreviewPDA.iconOverlay[moSetGetOverlays.iconPreviewPDA.selectIcon].infoTxt;
					moSetGetOverlays:loadAppIconsOverlays(self, iconName, iconTyp, infoTxt, nil, whichSubPDA)
					moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconTyp = iconTyp;
					moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconName = iconName;
					g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;
				end;
			end;
			return;
		end;
	end;	
end;

function moMouseKeyMohPDA:setColorIconTyp3(self, clickAreaTable, whichPDA)
	local whichSubPDA = whichPDA or tostring(clickAreaTable.whereClick);
	local iconName = moSetGetOverlays.pda[whichSubPDA].line[clickAreaTable.line].app[clickAreaTable.appIcon].iconName;
	if moSetGetOverlays.appIcon[whichSubPDA][iconName] ~= nil then
		local iconTyp = Utils.getNoNil(moSetGetOverlays.appIcon[whichSubPDA][iconName].iconTyp, 0);
		if iconTyp == 3 then
			if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable.typ3 ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable.typ3.color ~= nil then
				if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable.typ3.color[3] then moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable.typ3.color[3] = false;else moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable.typ3.color[3] = true;end;
			end;
		end;
	end;
end;

--only select App with Mouse
function moMouseKeyMohPDA:appSelectOrOpenApp(self, clickAreaTable, whichPDA)
	local whichSubPDA = whichPDA or tostring(clickAreaTable.whereClick);
	if moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line == clickAreaTable.line and moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app == clickAreaTable.appIcon and moSetGetOverlays.pda[whichSubPDA].appMouseSelect.pda == 1 then
		moMouseKeyMohPDA:appSelectAndOpenApp(self, clickAreaTable, whichSubPDA);
	else
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line = clickAreaTable.line;
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app = clickAreaTable.appIcon;
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.pda = 1;
		moSetGetOverlays.pda[whichSubPDA].line[clickAreaTable.line].appSettingSelect = clickAreaTable.appIcon; --for Extra at Setting Open		
		moSetGetGuiMenue:setAppMouseSelectButtoTxt(whichSubPDA, false, true, false, true);
		tabletPdaDefaultSide3:appCmdTableHidden(whichSubPDA);
	end;
end;

function moMouseKeyMohPDA:appSelectAndOpenApp(self, clickAreaTable, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_";
end;

--only upDown Buttons (Mouse) not keySelect
function moMouseKeyMohPDA:nextViewLine(self, up, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_";
	local viewLines = {};
	for a=1, #moSetGetOverlays.pda[whichSubPDA].renderViewLines do		
		local line = moSetGetOverlays.pda[whichSubPDA].renderViewLines[a];			
		moSetGetOverlays.pda[whichSubPDA].line[line].view = false;
		if up then
			if line-1 < 1 then 
				line = #moSetGetOverlays.pda[whichSubPDA].line;				
			else
				line = line-1;
			end;			
		else
			if line+1 > #moSetGetOverlays.pda[whichSubPDA].line then 
				line = 1;				
			else
				line = line+1;
			end;			
		end;		
		table.insert(viewLines, #viewLines+1, line);		
	end;
	moSetGetOverlays.pda[whichSubPDA].renderViewLines = {};
	moSetGetOverlays.pda[whichSubPDA].renderViewLines = viewLines;
	for a=1, #moSetGetOverlays.pda[whichSubPDA].renderViewLines do
		moSetGetOverlays.pda[whichSubPDA].line[moSetGetOverlays.pda[whichSubPDA].renderViewLines[a]].view = true;	
	end;	
end;

--only LeftRight Buttons (Mouse) not keySelect
function moMouseKeyMohPDA:nextAppSelect(self, left, line, whichPDA)	
	local whichSubPDA = whichPDA or "masterPDA_";
	local appSelect = 0
	if left then
		appSelect = moSetGetOverlays.pda[whichSubPDA].line[line].appSelect-1;
		if appSelect < 1 then appSelect = moSetGetOverlays.pda[whichSubPDA].line[line].appsAtLine;end;
	else
		appSelect = moSetGetOverlays.pda[whichSubPDA].line[line].appSelect+1;
		if appSelect > moSetGetOverlays.pda[whichSubPDA].line[line].appsAtLine then appSelect = 1;end;
	end;
	moSetGetOverlays.pda[whichSubPDA].line[line].appSelect = appSelect;	
end;

function moMouseKeyMohPDA:openSetting(self, whichPDA, pdaMenue) --open/close Gui Menue
	local whichSubPDA = whichPDA or "masterPDA_";	
	if MultiOverlayV3.guiMenue.on == nil then g_currentMission:showBlinkingWarning("Gui Menue Setting Pages not found\nCheck Error or Info at file log.txt", 2500);return;end;
	if pdaMenue ~= nil and pdaMenue == 1 then
		if g_currentMission.guiMenue.master.isOpen() then
			local isClose = g_currentMission.guiMenue.master.closenGuiMenue(MultiOverlayV3.guiMenue.modTable, true); --true for stop onCloseCallback	
			if isClose then 
				moSetGetCallbacksGuiMenue.onCloseCallback(nil, whichPDA); --set trigger manual
				--MultiOverlayV3.guiMenue.on = false;
				--if whichSubPDA == "masterPDA_" then			
				--	moSetGetMohPDA.setOpenCloseSettingsPDA(self, whichSubPDA, nil, true);
				--else
				--	moSetGetMohPDA.setOpenCloseSettingsPDA(self, whichSubPDA, true, nil);
				--end;
			end;
		elseif MultiOverlayV3.guiMenue.modTable ~= nil and MultiOverlayV3.guiMenue.modTable > 0 then		
			local isOpen = g_currentMission.guiMenue.master.openGuiMenue(MultiOverlayV3.guiMenue.modTable, true); --true for stop onOpenCallback
			if isOpen then
				moSetGetCallbacksGuiMenue.onOpenCallback(nil, whichPDA); --set trigger manual
				--MultiOverlayV3.guiMenue.on = true;			
				--moSetGetMohPDA.setOpenCloseSettingsPDA(self, whichSubPDA, true, true);
			end;
		else
			g_currentMission:showBlinkingWarning("Gui Menue Mod Pages not found\nCheck Error or Info at file log.txt", 2500);
		end;		
	end;
end;

function moMouseKeyMohPDA:resetPdaSelectKeyAndApps(keySelect, appMouseSelect, whichPDA) --free
	local whichSubPDA = whichPDA or "masterPDA_";
	if keySelect then
		moSetGetOverlays.pda[whichSubPDA].keySelect.line = 1;
		moSetGetOverlays.pda[whichSubPDA].keySelect.app = 1;
		moSetGetOverlays.pda[whichSubPDA].keySelect.pda = 1;
	elseif appMouseSelect then
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line = 1;
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app = 1;
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.pda = 1;
		tabletPdaDefaultSide3:appCmdTableHidden(whichSubPDA);
	end;
end;